
#include <SPI.h>
#include <UIPEthernet.h>

String LogerID = "TNLG01N"; //7 char only
String sCom;

unsigned long DCount[10] = {0,0,0,0,0,0,0,0,0,0};
boolean DLast[10] = {0,0,0,0,0,0,0,0,0,0};
unsigned long lastime = 0;
unsigned long AnRead = 0;
int comtime = 0;

// Enter a MAC address and IP address for your controller below.
// The IP address will be dependent on your local network:
byte mac[] = {

  0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED
};

//IPAddress ip(192, 168, 1, 211);
// Enter the IP address of the server you're connecting to:

IPAddress server(202, 152, 39, 218);

// Initialize the Ethernet client library
// with the IP address and port of the server
EthernetClient client;

void(*resetFunc)(void)=0; //reset function @ address 0

void setup() {

  // turn modem ON agar DHCP aktif
  SetModem(HIGH);
  //wait DHCP server active
  //mydelay(15);
  
  // Open serial communications and wait for port to open:
  Serial.begin(9600);

  while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }

  // You can use Ethernet.init(pin) to configure the CS pin
  //Ethernet.init(10);  // Most Arduino shields
  //Ethernet.init(5);   // MKR ETH shield
  //Ethernet.init(0);   // Teensy 2.0
  //Ethernet.init(20);  // Teensy++ 2.0
  //Ethernet.init(15);  // ESP8266 with Adafruit Featherwing Ethernet
  //Ethernet.init(33);  // ESP32 with Adafruit Featherwing Ethernet
  // start the Ethernet connection:
  // Ethernet.begin(mac, ip);
  Ethernet.begin(mac);
  
}

void loop() {

  // Hidupkan modem
  SetModem(HIGH);
 
  Ethernet.maintain();

  Serial.print(Ethernet.localIP());
  Serial.println(" connecting...");
  // give the Ethernet shield a second to initialize:
  mydelay(1);

  // if you get a connection, report back via serial:
  if (client.connect(server, 6013)) {
    Serial.println("connected");
  } else {
    // if you didn't get a connection to the server:
    Serial.println("connection failed");
  }
  
  // as long as there are bytes in the serial queue,
  // read them and send them out the socket if it's open:
    if (client.connected()) {
      sCom = "";
      // read the analog in value:
      for (int pin=0; pin<=7; pin++) {
        // cleaning last reading
        for (int ulang=0; ulang<=10; ulang++) {
          AnRead = analogRead(pin);
          delay(2);
        }
        AnRead = 0;
        for (int ulang=1; ulang<=5; ulang++) {
          AnRead = analogRead(pin)+ AnRead;
          delay(1);
        }
        AnRead = AnRead / 5;
        sCom = sCom + "A" + String(pin) + "-" + String(AnRead) + ";";
      } 

    // send the digital in value
      sCom = sCom + "D-";
    // in D5-D9 
      for (int pin=5; pin<=9; pin++) {
        sCom = sCom + String(digitalRead(pin));
      }
    sCom = sCom + ";" ;
    // digital counter 
      for (int pin=5; pin<=9; pin++) {
        sCom = sCom + "C" + String(pin) + "-" + String(DCount[pin-2]) + ";";
      }

    // com time transfer mark
    comtime = comtime + 1;
    if (comtime > 99) {comtime = 0; }
    sCom = sCom + "T" + String(comtime) + ";";
    
    // End transmission with loger ID  
    sCom = sCom + LogerID ;
    Serial.println(sCom);
    client.print(sCom);
    client.stop();
    Serial.println("disconnected..");
    // matikan modem
    SetModem(LOW);
    //sleep for next transmission
    mydelay(1);
    // Hidupkan kembali modem
    SetModem(HIGH);
    //wait for modem connect to internet
    mydelay(5);

  }

  // if the server's disconnected, stop the client:
  //if (!client.connected()) {
    //Serial.println();
    //Serial.println("reset..");
    //client.stop();

    // resetFunc();
  //}

}

void mydelay(int detik) {
  for (int pin=0; pin<=detik; pin++) {
    msecdelay(1000);  
  }
}

void msecdelay(unsigned long mDetik) {
  // baca counter digital hingga transmisi serial berikutnya
  lastime = millis();
  while (millis()  < (lastime + mDetik)) {
    //reset jika milis kembali 0
    if (millis() < lastime) {lastime = millis();}
    // read digital value
    for (int pin=5; pin<=9; pin++) {
      pinMode(pin, INPUT);
      boolean DigiState = digitalRead(pin);
      // count when state change high to low
      if ((DLast[pin-2] == HIGH) and (DigiState == LOW))
      {
        DCount[pin-2] = DCount[pin-2] + 1;
      }
      DLast[pin-2] = DigiState;
    }
  }
}

void SetModem(boolean bStatus) {
  pinMode(2, OUTPUT);
  digitalWrite(2, bStatus);
}
